// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__7E22AC67_E1CA_11D1_B719_0080AD17AF01__INCLUDED_)
#define AFX_MAINFRM_H__7E22AC67_E1CA_11D1_B719_0080AD17AF01__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum{ OPERATION_LINE, OPERATION_RECTANGLE,
	OPERATION_ELLIPSE };

typedef struct{
	int nOperation;
	COLORREF cColor;
	int nX1, nY1, nX2, nY2;
} DRAW_EVENT;

#define MAX_DRAW_EVENTS 50

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:
	DRAW_EVENT m_DrawEvent[MAX_DRAW_EVENTS];
	int m_nCurrentDrawEvent;

	COLORREF m_cColor;
	int m_nOperation;

	void ShowCount( void );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnColorRed();
	afx_msg void OnUpdateColorRed(CCmdUI* pCmdUI);
	afx_msg void OnColorBlue();
	afx_msg void OnUpdateColorBlue(CCmdUI* pCmdUI);
	afx_msg void OnColorGreen();
	afx_msg void OnUpdateColorGreen(CCmdUI* pCmdUI);
	afx_msg void OnOperationLine();
	afx_msg void OnOperationRectangle();
	afx_msg void OnOperationEllipse();
	afx_msg void OnEditClear();
	afx_msg void OnEditUndo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__7E22AC67_E1CA_11D1_B719_0080AD17AF01__INCLUDED_)
